#ifndef _INLINE_AMIGAGUIDE_H
#define _INLINE_AMIGAGUIDE_H

#include <sys/cdefs.h>
#include <inline/stubs.h>

__BEGIN_DECLS

#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct Library*  AmigaGuideBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME AmigaGuideBase
#endif

static __inline LONG 
ARexxHost (BASE_PAR_DECL struct RexxMsg *rmsg,STRPTR *result)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register struct RexxMsg *a0 __asm("a0") = rmsg;
  register STRPTR *a1 __asm("a1") = result;
  __asm __volatile ("jsr a6@(-0x1e)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline ULONG 
AddAmigaGuideHostA (BASE_PAR_DECL struct Hook *h,STRPTR name,struct TagItem *attrs)
{
  BASE_EXT_DECL
  register ULONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register struct Hook *a0 __asm("a0") = h;
  register STRPTR d0 __asm("d0") = name;
  register struct TagItem *a1 __asm("a1") = attrs;
  __asm __volatile ("jsr a6@(-0x8a)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline BPTR 
AddPathEntries (BASE_PAR_DECL BPTR path,STRPTR *argptr)
{
  BASE_EXT_DECL
  register BPTR  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register BPTR a0 __asm("a0") = path;
  register STRPTR *d0 __asm("d0") = argptr;
  __asm __volatile ("jsr a6@(-0xa8)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline ULONG 
AmigaGuideSignal (BASE_PAR_DECL APTR cl)
{
  BASE_EXT_DECL
  register ULONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  __asm __volatile ("jsr a6@(-0x48)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void 
CloseAmigaGuide (BASE_PAR_DECL APTR cl)
{
  BASE_EXT_DECL
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  __asm __volatile ("jsr a6@(-0x42)"
  : /* no output */
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
}
static __inline LONG 
CloseDataBase (BASE_PAR_DECL struct DataBase *db)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register struct DataBase *a0 __asm("a0") = db;
  __asm __volatile ("jsr a6@(-0xcc)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline BPTR 
CopyPathList (BASE_PAR_DECL BPTR path)
{
  BASE_EXT_DECL
  register BPTR  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register BPTR a0 __asm("a0") = path;
  __asm __volatile ("jsr a6@(-0xa2)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void 
ExpungeDataBases (BASE_PAR_DECL long flush)
{
  BASE_EXT_DECL
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register long d0 __asm("d0") = flush;
  __asm __volatile ("jsr a6@(-0x30)"
  : /* no output */
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
}
static __inline void 
ExpungeXRef (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct Library* a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x84)"
  : /* no output */
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
}
static __inline void 
FreePathList (BASE_PAR_DECL BPTR path)
{
  BASE_EXT_DECL
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register BPTR a0 __asm("a0") = path;
  __asm __volatile ("jsr a6@(-0xae)"
  : /* no output */
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
}
static __inline LONG 
GetAmigaGuideAttr (BASE_PAR_DECL ULONG tag,APTR cl,ULONG *storage)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register ULONG d0 __asm("d0") = tag;
  register APTR a0 __asm("a0") = cl;
  register ULONG *a1 __asm("a1") = storage;
  __asm __volatile ("jsr a6@(-0x72)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct AmigaGuideMsg *
GetAmigaGuideMsg (BASE_PAR_DECL APTR cl)
{
  BASE_EXT_DECL
  register struct AmigaGuideMsg * _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  __asm __volatile ("jsr a6@(-0x4e)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline STRPTR 
GetAmigaGuideString (BASE_PAR_DECL long id)
{
  BASE_EXT_DECL
  register STRPTR  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register long d0 __asm("d0") = id;
  __asm __volatile ("jsr a6@(-0xd2)"
  : "=r" (_res)
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
LoadNode (BASE_PAR_DECL APTR cl,struct DataBase *db,struct HelpNode *hn)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  register struct DataBase *a1 __asm("a1") = db;
  register struct HelpNode *a2 __asm("a2") = hn;
  __asm __volatile ("jsr a6@(-0xc0)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
  return _res;
}
static __inline LONG 
LoadXRef (BASE_PAR_DECL BPTR lock,STRPTR name)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register BPTR a0 __asm("a0") = lock;
  register STRPTR a1 __asm("a1") = name;
  __asm __volatile ("jsr a6@(-0x7e)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
LockAmigaGuideBase (BASE_PAR_DECL APTR handle)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = handle;
  __asm __volatile ("jsr a6@(-0x24)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline BPTR 
LockE (BASE_PAR_DECL BPTR path,STRPTR name,long mode)
{
  BASE_EXT_DECL
  register BPTR  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register BPTR a0 __asm("a0") = path;
  register STRPTR d1 __asm("d1") = name;
  register long d2 __asm("d2") = mode;
  __asm __volatile ("jsr a6@(-0x9c)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d1), "r" (d2)
  : "a0","a1","d0","d1","d2", "memory");
  return _res;
}
static __inline APTR 
OpenAmigaGuideA (BASE_PAR_DECL struct NewAmigaGuide *nag,struct TagItem *tag)
{
  BASE_EXT_DECL
  register APTR  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register struct NewAmigaGuide *a0 __asm("a0") = nag;
  register struct TagItem * a1 __asm("a1") = tag;
  __asm __volatile ("jsr a6@(-0x36)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline APTR 
OpenAmigaGuideAsyncA (BASE_PAR_DECL struct NewAmigaGuide *nag,struct TagItem *attrs)
{
  BASE_EXT_DECL
  register APTR  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register struct NewAmigaGuide *a0 __asm("a0") = nag;
  register struct TagItem *d0 __asm("d0") = attrs;
  __asm __volatile ("jsr a6@(-0x3c)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct DataBase *
OpenDataBase (BASE_PAR_DECL BPTR lock,STRPTR name)
{
  BASE_EXT_DECL
  register struct DataBase * _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register BPTR a0 __asm("a0") = lock;
  register STRPTR a1 __asm("a1") = name;
  __asm __volatile ("jsr a6@(-0xba)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline BPTR 
OpenE (BASE_PAR_DECL BPTR path,STRPTR name,long mode)
{
  BASE_EXT_DECL
  register BPTR  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register BPTR a0 __asm("a0") = path;
  register STRPTR d1 __asm("d1") = name;
  register long d2 __asm("d2") = mode;
  __asm __volatile ("jsr a6@(-0x96)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d1), "r" (d2)
  : "a0","a1","d0","d1","d2", "memory");
  return _res;
}
static __inline ULONG 
ParsePathString (BASE_PAR_DECL STRPTR line,STRPTR *argv,unsigned long max)
{
  BASE_EXT_DECL
  register ULONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register STRPTR d0 __asm("d0") = line;
  register STRPTR *a0 __asm("a0") = argv;
  register unsigned long d1 __asm("d1") = max;
  __asm __volatile ("jsr a6@(-0xb4)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
RemoveAmigaGuideHostA (BASE_PAR_DECL APTR hh,struct TagItem *attrs)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = hh;
  register struct TagItem *a1 __asm("a1") = attrs;
  __asm __volatile ("jsr a6@(-0x90)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void 
ReplyAmigaGuideMsg (BASE_PAR_DECL struct AmigaGuideMsg *amsg)
{
  BASE_EXT_DECL
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register struct AmigaGuideMsg *a0 __asm("a0") = amsg;
  __asm __volatile ("jsr a6@(-0x54)"
  : /* no output */
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
}
static __inline LONG 
SendAmigaGuideCmdA (BASE_PAR_DECL APTR cl,STRPTR cmd,struct TagItem *attrs)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  register STRPTR d0 __asm("d0") = cmd;
  register struct TagItem *d1 __asm("d1") = attrs;
  __asm __volatile ("jsr a6@(-0x66)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
SendAmigaGuideContextA (BASE_PAR_DECL APTR cl,struct TagItem *attrs)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  register struct TagItem *d0 __asm("d0") = attrs;
  __asm __volatile ("jsr a6@(-0x60)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
SetAmigaGuideAttrsA (BASE_PAR_DECL APTR cl,struct TagItem *attrs)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  register struct TagItem *a1 __asm("a1") = attrs;
  __asm __volatile ("jsr a6@(-0x6c)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
SetAmigaGuideContextA (BASE_PAR_DECL APTR cl,unsigned long id,struct TagItem *attrs)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  register unsigned long d0 __asm("d0") = id;
  register struct TagItem *d1 __asm("d1") = attrs;
  __asm __volatile ("jsr a6@(-0x5a)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline LONG 
SetAmigaGuideHook (BASE_PAR_DECL APTR cl,unsigned long v1,unsigned long v2,unsigned long v3)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  register unsigned long d0 __asm("d0") = v1;
  register unsigned long a1 __asm("a1") = v2;
  register unsigned long a2 __asm("a2") = v3;
  __asm __volatile ("jsr a6@(-0x78)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
  return _res;
}
static __inline LONG 
UnloadNode (BASE_PAR_DECL APTR cl,struct DataBase *db,struct HelpNode *hn)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register APTR a0 __asm("a0") = cl;
  register struct DataBase *a1 __asm("a1") = db;
  register struct HelpNode *a2 __asm("a2") = hn;
  __asm __volatile ("jsr a6@(-0xc6)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
  return _res;
}
static __inline void 
UnlockAmigaGuideBase (BASE_PAR_DECL long key)
{
  BASE_EXT_DECL
  register struct Library* a6 __asm("a6") = BASE_NAME;
  register long d0 __asm("d0") = key;
  __asm __volatile ("jsr a6@(-0x2a)"
  : /* no output */
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME

__END_DECLS

#endif /* _INLINE_AMIGAGUIDE_H */
